# UniTAP.dev.ports.modules.vtg.timing_manager

class TimingManager:

Class `TimingManager` allows working with all available predefined timings from device. You can get cvt timing by index `get_cvt`, dmt timing by index `get_dmt`, cta timing by index `get_cta`, get list of all timing `get_all` ot search timing by parameters `search`.

TimingManager(available_list: List[ UniTAP.common.timing.Timing ])
def get_cvt(self, index: int) -> Optional[ UniTAP.common.timing.Timing ]:

Returns cvt `Timing` by index.

###### Arguments:

- index (int): CVT timing index

###### Returns:

> timing (Timing | None) - type `Timing` if search was success, `None` if not.

def get_dmt(self, index: int) -> Optional[ UniTAP.common.timing.Timing ]:

Returns cvt `Timing` by index.

###### Arguments:

- index (int): DMT timing index

###### Returns:

> timing (Timing | None) - type `Timing` if search was success, `None` if not.

def get_cta(self, index: int) -> Optional[ UniTAP.common.timing.Timing ]:

Returns cvt `Timing` by index.

###### Arguments:

- index (int): CTA timing index

###### Returns:

> timing (Timing | None) - type `Timing` if search was success, `None` if not.

def get_all(self) -> List[ UniTAP.common.timing.Timing ]:

Returns list of `Timing` objects.

###### Returns:

> timing (list[Timing])

def get_by_list_index(self, index: int) -> Optional[ UniTAP.common.timing.Timing ]:

Returns `Timing` objects by index in timings list.

###### Arguments:

- index (int) index of timing in list

###### Returns:

> timing (Timing)

def print_all(self) -> str:

Print list of `Timing` objects.

###### Returns:

> str

def search( self, h_active: Optional[int] = None, v_active: Optional[int] = None, f_rate: Optional[int] = None, standard: Optional[ UniTAP.common.timing.Timing.Standard ] = None, rb: Optional[ UniTAP.common.timing.Timing.ReduceBlanking ] = None) -> Optional[ UniTAP.common.timing.Timing ]:

Search timing by transferred parameters.

###### Arguments:

- h_active (int | None): h active resolution of timing
- v_active (int | None): v active resolution of timing
- f_rate (int | None): frame rate of timing
- standard (Standard | None): timing `Standard`
- rb (ReduceBlanking | None): timing `ReduceBlanking`

###### Returns:

> timing (Timing | None) - type `Timing` if search was success, `None` if not.